<template>
  <div class="mb-2">
    <label :for="fieldPrefix + field.name" v-if="field.label">
      {{ field.label }}
      <RequiredIcon v-if="isRequired" />
      <InfoTooltip v-if="field.tooltip" :text="field.tooltip" />
    </label>
    <textarea
      :id="fieldPrefix + field.name"
      :class="['form-control', { 'border-danger': hasError }]"
      :maxlength="field.maxlength"
      v-model="fieldValue"
      :disabled="field.disabled || busy"
      @input="onInput"
    ></textarea>
    <div class="text-danger" v-if="error">{{ error }}</div>
  </div>
</template>

<script>
import { useVFormControl } from '../../plugins/vform-plugin.js'
import InfoTooltip from '../info-tooltip.vue'
import RequiredIcon from '../required-icon.vue'

export default {
  name: 'VFormTextarea',
  props: {
    formName: { type: String, required: true },
    field: { type: Object, required: true },
    fieldPrefix: { type: String, required: true },
    modelState: { type: Object, default: null }, // Taken from the API response if validation fails at the server.
    busy: { type: Boolean, default: false },
  },
  components: {
    InfoTooltip,
    RequiredIcon,
  },
  setup(props, context) {
    return useVFormControl(props, context)
  },
}
</script>
